; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Module - V0.9.2
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - BasicMethods.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 22-07-2018
; Mise  jour : 03-08-2018
; Cod pour PureBasic : V5.70 beta 1
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule BasicMethods

  Declare.b GetObservator()
  Declare.b GetMutator()
  Declare.b GetUpdate()
  Declare.b GetInitialize()
  Declare.b GetReset()
  Declare SetObservator(P_Observator.b)
  Declare SetMutator(P_Mutator.b)
  Declare SetUpdate(P_Update.b)
  Declare SetInitialize(P_Initialize.b)
  Declare SetReset(P_Reset.b)
  Declare Reset()
  Declare ReadPrefs(P_GroupName.s)
  Declare WritePrefs(P_GroupName.s)
  Declare.s DeclareObservators()
  Declare.s DeclareMutators()
  Declare.s DeclareUpdate()
  Declare.s DeclareInitialize()
  Declare.s DeclareReset()
  Declare.s DefineObservators()
  Declare.s DefineMutators()
  Declare.s DefineUpdate()
  Declare.s DefineInitialize()
  Declare.s DefineReset()
  
EndDeclareModule

Module BasicMethods

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Dclaration de la Structure <<<<<

  Structure Instance

    Observator.b
    Mutator.b
    Update.b
    Initialize.b
    Reset.b

  EndStructure

  Global Instance.Instance

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les observateurs <<<<<

  Procedure.b GetObservator()

    ProcedureReturn Instance\Observator
  EndProcedure

  Procedure.b GetMutator()

    ProcedureReturn Instance\Mutator
  EndProcedure

  Procedure.b GetUpdate()

    ProcedureReturn Instance\Update
  EndProcedure

  Procedure.b GetInitialize()

    ProcedureReturn Instance\Initialize
  EndProcedure

  Procedure.b GetReset()

    ProcedureReturn Instance\Reset
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les mutateurs <<<<<

  Procedure SetObservator(P_Observator.b)

    Instance\Observator = P_Observator

  EndProcedure

  Procedure SetMutator(P_Mutator.b)

    Instance\Mutator = P_Mutator

  EndProcedure

  Procedure SetUpdate(P_Update.b)

    Instance\Update = P_Update

  EndProcedure

  Procedure SetInitialize(P_Initialize.b)

    Instance\Initialize = P_Initialize

  EndProcedure

  Procedure SetReset(P_Reset.b)

    Instance\Reset = P_Reset

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Reset <<<<<

  Procedure Reset()
    
    Instance\Observator = 0
    Instance\Mutator = 0
    Instance\Update = 0
    Instance\Initialize = 0
    Instance\Reset = 0
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Lecture d'un groupe Prfrences <<<<<

  Procedure ReadPrefs(P_GroupName.s)

    PreferenceGroup(P_GroupName)
    
    Instance\Observator = ReadPreferenceLong("Observator", Instance\Observator)
    Instance\Mutator = ReadPreferenceLong("Mutator", Instance\Mutator)
    Instance\Update = ReadPreferenceLong("Update", Instance\Update)
    Instance\Initialize = ReadPreferenceLong("Initialize", Instance\Initialize)
    Instance\Reset = ReadPreferenceLong("Reset", Instance\Reset)
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture d'un groupe de Prfrences <<<<<

  Procedure WritePrefs(P_GroupName.s)

    PreferenceGroup(P_GroupName)
    
    WritePreferenceLong("Observator", Instance\Observator)
    WritePreferenceLong("Mutator", Instance\Mutator)
    WritePreferenceLong("Update", Instance\Update)
    WritePreferenceLong("Initialize", Instance\Initialize)
    WritePreferenceLong("Reset", Instance\Reset)
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration des Observateurs <<<<<
  
  Procedure.s DeclareObservators()
    
    If Field::FirstInstance(0)
      
      Repeat
        
        If Field::GetFieldType(0) <> Field::#FIELD_TYPE_STRUCTURE
          
          If Field::GetFieldName(0) = "ID" And Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_MULTIPLE_ID
            
            Buffer.s + ""
            
          Else
            
            Select Field::GetFieldStyle(0)
                
              Case Field::#FIELD_STYLE_ARRAY
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME  
                    Buffer + Comments::Tabulation(1) + "Declare Get" + Field::GetFieldName(0) + "(Array Destination" + Field::GetFieldExtensionLong(0) + "(" + Str(Field::GetFieldDynamicArrayDimensionCount(0)) + "))" + Field::#LineFeed
                    
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    Buffer + Comments::Tabulation(1) + "Declare Get" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", Array Destination." + Field::GetFieldExtensionShort(0) + "(" + Str(Field::GetFieldDynamicArrayDimensionCount(0)) + "))" + Field::#LineFeed
                    
                EndSelect
                
              Case Field::#FIELD_STYLE_LIST
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME 
                    Buffer + Comments::Tabulation(1) + "Declare Get" + Field::GetFieldName(0) + "(List Destination" + Field::GetFieldExtensionLong(0) + "())" + Field::#LineFeed
                    
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    Buffer + Comments::Tabulation(1) + "Declare Get" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", List Destination." + Field::GetFieldExtensionShort(0) + "())" + Field::#LineFeed
                    
                EndSelect
                
              Case Field::#FIELD_STYLE_MAP
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME
                    Buffer + Comments::Tabulation(1) + "Declare Get" + Field::GetFieldName(0) + "(Map Destination" + Field::GetFieldExtensionLong(0) + "())" + Field::#LineFeed
                    
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    Buffer + Comments::Tabulation(1) + "Declare Get" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", Map Destination." + Field::GetFieldExtensionShort(0) + "())" + Field::#LineFeed
                    
                EndSelect
                
              Case Field::#FIELD_STYLE_BASIC
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME  
                    If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
                      Buffer + Comments::Tabulation(1) + "Declare Get" + Field::GetFieldName(0) + "(*P_" + Field::GetFieldName(0) + "." + Field::GetFieldExternModuleName(0) + "::" + Field::GetFieldExternModuleStructure(0)  + " = #Null)" + Field::#LineFeed
                    ElseIf Field::GetFieldType(0) < Field::#FIELD_TYPE_STRUCTURE
                      Buffer + Comments::Tabulation(1) + "Declare" + Field::GetFieldExtensionLong(0) + " Get" + Field::GetFieldName(0) + "()" + Field::#LineFeed
                    EndIf    
                    
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
                      Buffer + Comments::Tabulation(1) + "Declare.i Get" + Field::GetFieldName(0) + "(*" + Field::GetFieldName(0) + "A." + Field::GetFieldName(0) + ", *P_" + Field::GetFieldName(0) + "." + Field::GetFieldExternModuleName(0) + "::" + Field::GetFieldExternModuleStructure(0) + " = #Null)" + Field::#LineFeed
                    ElseIf Field::GetFieldType(0) < Field::#FIELD_TYPE_STRUCTURE
                      Buffer + Comments::Tabulation(1) + "Declare" + Field::GetFieldExtensionLong(0) + " Get" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ")" + Field::#LineFeed
                    EndIf
                    
                EndSelect
                
              Case Field::#FIELD_STYLE_BASIC_ARRAY
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME  
                    If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
                      Buffer + Comments::Tabulation(1) + "Declare Get" + Field::GetFieldName(0) + "(" + Field::GetFieldArrayIndexName(0) + ".l, *P_" + Field::GetFieldName(0) + "." + Field::GetFieldExternModuleName(0) + "::" + Field::GetFieldExternModuleStructure(0) + " = #Null)" + Field::#LineFeed
                    ElseIf Field::GetFieldType(0) < Field::#FIELD_TYPE_STRUCTURE
                      Buffer + Comments::Tabulation(1) + "Declare" + Field::GetFieldExtensionLong(0) + " Get" + Field::GetFieldName(0) + "(" + Field::GetFieldArrayIndexName(0) + ".l)" + Field::#LineFeed
                    EndIf
                    
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    Buffer + Comments::Tabulation(1) + "Declare" + Field::GetFieldExtensionLong(0) + " Get" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", " + Field::GetFieldArrayIndexName(0) + ".l)" + Field::#LineFeed
                    
                EndSelect
                
            EndSelect
            
          EndIf
          
        EndIf
        
      Until Field::NextInstance(0) = #Null
      
    EndIf
    
    If Field::FirstInstance(1)
      
      Repeat
        
        If Field::GetFieldType(1) <> Field::#FIELD_TYPE_STRUCTURE
          
          Select Field::GetFieldStyle(1)
              
            Case Field::#FIELD_STYLE_ARRAY
              Buffer + Comments::Tabulation(1) + "Declare Get" + Field::GetFieldName(1) + "(Array Destination" + Field::GetFieldExtensionLong(1) + "(" + Str(Field::GetFieldDynamicArrayDimensionCount(1)) + "))" + Field::#LineFeed
              
            Case Field::#FIELD_STYLE_LIST
              Buffer + Comments::Tabulation(1) + "Declare Get" + Field::GetFieldName(1) + "(List Destination" + Field::GetFieldExtensionLong(1) + "())" + Field::#LineFeed
              
            Case Field::#FIELD_STYLE_MAP
              Buffer + Comments::Tabulation(1) + "Declare Get" + Field::GetFieldName(1) + "(Map Destination" + Field::GetFieldExtensionLong(1) + "())" + Field::#LineFeed
              
            Case Field::#FIELD_STYLE_BASIC
              If Field::GetFieldType(1) = Field::#FIELD_TYPE_MODULE
                Buffer + Comments::Tabulation(1) + "Declare Get" + Field::GetFieldName(1) + "(*P_" + Field::GetFieldName(1) + "." + Field::GetFieldExternModuleName(1) + "::" + Field::GetFieldExternModuleStructure(1) + " = #Null)" + Field::#LineFeed
              ElseIf Field::GetFieldType(1) < Field::#FIELD_TYPE_STRUCTURE
                Buffer + Comments::Tabulation(1) + "Declare" + Field::GetFieldExtensionLong(1) + " Get" + Field::GetFieldName(1) + "()" + Field::#LineFeed
              EndIf
              
            Case Field::#FIELD_STYLE_BASIC_ARRAY
              If Field::GetFieldType(1) = Field::#FIELD_TYPE_MODULE
                Buffer + Comments::Tabulation(1) + "Declare Get" + Field::GetFieldName(1) + "(" + Field::GetFieldArrayIndexName(1) + ".l, *P_" + Field::GetFieldName(1) + "." + Field::GetFieldExternModuleName(1) + "::" + Field::GetFieldExternModuleStructure(1) + " = #Null)" + Field::#LineFeed
              ElseIf Field::GetFieldType(1) < Field::#FIELD_TYPE_STRUCTURE
                Buffer + Comments::Tabulation(1) + "Declare" + Field::GetFieldExtensionLong(1) + " Get" + Field::GetFieldName(1) + "(" + Field::GetFieldArrayIndexName(1) + ".l)" + Field::#LineFeed
              EndIf
              
          EndSelect
          
        EndIf
        
      Until Field::NextInstance(1) = #Null
      
    EndIf
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration des Mutateurs <<<<<
  
  Procedure.s DeclareMutators()
    
    If Field::FirstInstance(1)
      
      Repeat
        
        If Field::GetFieldType(0) <> Field::#FIELD_TYPE_STRUCTURE
          
          If Field::GetFieldName(0) = "ID" And Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_MULTIPLE_ID
            
            Buffer.s + ""
            
          Else
            
            Select Field::GetFieldStyle(0)
                
              Case Field::#FIELD_STYLE_ARRAY
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME
                    Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(0) + "(Array Source" + Field::GetFieldExtensionLong(0) + "(" + Str(Field::GetFieldDynamicArrayDimensionCount(0)) + "))" + Field::#LineFeed
                    
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", Array Source" + Field::GetFieldExtensionLong(0) + "(" + Str(Field::GetFieldDynamicArrayDimensionCount(0)) + "))" + Field::#LineFeed
                    
                EndSelect
                
              Case Field::#FIELD_STYLE_LIST
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME 
                    Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(0) + "(List Source." + Field::GetFieldExtensionShort(0) + "())" + Field::#LineFeed
                    
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", List Source" + Field::GetFieldExtensionLong(0) + "())" + Field::#LineFeed
                    
                EndSelect
                
              Case Field::#FIELD_STYLE_MAP
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME
                    Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(0) + "(Map Source." + Field::GetFieldExtensionShort(0) + "())" + Field::#LineFeed
                    
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", Map Source" + Field::GetFieldExtensionLong(0) + "())" + Field::#LineFeed
                    
                EndSelect
                
              Case Field::#FIELD_STYLE_BASIC
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME  
                    If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
                      Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(0) + "(*P_" + Field::GetFieldName(0) + "." + Field::GetFieldExternModuleName(0) + "::" + Field::GetFieldExternModuleStructure(0)  + ")" + Field::#LineFeed
                    ElseIf Field::GetFieldType(0) < Field::#FIELD_TYPE_STRUCTURE
                      Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(0) + "(P_" + Field::GetFieldName(0) + Field::GetFieldExtensionLong(0) + ")" + Field::#LineFeed
                    EndIf    
                    
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
                      Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(0) + "(*" + Field::GetFieldName(0) + "A." + Field::GetFieldName(0) + ", *P_" + Field::GetFieldName(0) + "." + Field::GetFieldExternModuleName(0) + "::" + Field::GetFieldExternModuleStructure(0) + ")" + Field::#LineFeed
                    ElseIf Field::GetFieldType(0) < Field::#FIELD_TYPE_STRUCTURE
                      Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", P_" + Field::GetFieldName(0) + Field::GetFieldExtensionLong(0) +")" + Field::#LineFeed
                    EndIf
                    
                EndSelect
                
              Case Field::#FIELD_STYLE_BASIC_ARRAY
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME  
                    If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
                      Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(0) + "(" + Field::GetFieldArrayIndexName(0) + ".l, *P_" + Field::GetFieldName(0) + "." + Field::GetFieldExternModuleName(0) + "::" + Field::GetFieldExternModuleStructure(0) + ")" + Field::#LineFeed
                    ElseIf Field::GetFieldType(0) < Field::#FIELD_TYPE_STRUCTURE
                      Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(0) + "(" + Field::GetFieldArrayIndexName(0) + ".l, P_" + Field::GetFieldName(0) + Field::GetFieldExtensionLong(0) + ")" + Field::#LineFeed
                    EndIf
                    
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", " + Field::GetFieldArrayIndexName(0) + ".l)" + Field::#LineFeed
                    
                EndSelect
                
            EndSelect
            
          EndIf
          
        EndIf
        
      Until Field::NextInstance(0) = #Null
      
    EndIf
    
    If Field::FirstInstance(1)
      
      Repeat
        
        If Field::GetFieldType(1) <> Field::#FIELD_TYPE_STRUCTURE
          
          Select Field::GetFieldStyle(1)
              
            Case Field::#FIELD_STYLE_ARRAY
              Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(1) + "(Array Source" + Field::GetFieldExtensionLong(1) + "(" + Str(Field::GetFieldDynamicArrayDimensionCount(1)) + "))" + Field::#LineFeed
              
            Case Field::#FIELD_STYLE_LIST
              Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(1) + "(List Source" + Field::GetFieldExtensionLong(1) + "())" + Field::#LineFeed
              
            Case Field::#FIELD_STYLE_MAP
              Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(1) + "(Map Source" + Field::GetFieldExtensionLong(1) + "())" + Field::#LineFeed
              
            Case Field::#FIELD_STYLE_BASIC
              If Field::GetFieldType(1) = Field::#FIELD_TYPE_MODULE
                Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(1) + "(*P_" + Field::GetFieldName(1) + Field::GetFieldExtensionLong(1) + ")" + Field::#LineFeed
              ElseIf Field::GetFieldType(1) < Field::#FIELD_TYPE_STRUCTURE
                Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(1) + "(P_" + Field::GetFieldName(1) + Field::GetFieldExtensionLong(1) + ")" + Field::#LineFeed
              EndIf
                      
            Case Field::#FIELD_STYLE_BASIC_ARRAY
              If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
                Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(1) + "(" + Field::GetFieldArrayIndexName(1) + ".l, *P_" + Field::GetFieldName(1) + "." + Field::GetFieldExternModuleName(1) + "::" + Field::GetFieldExternModuleStructure(1) + ")" + Field::#LineFeed
              ElseIf Field::GetFieldType(1) < Field::#FIELD_TYPE_STRUCTURE
                Buffer + Comments::Tabulation(1) + "Declare Set" + Field::GetFieldName(1) + "(" + Field::GetFieldArrayIndexName(1) + ".l, P_" + Field::GetFieldName(1) + Field::GetFieldExtensionLong(1)  + ")" + Field::#LineFeed
              EndIf
              
          EndSelect
          
        EndIf
        
      Until Field::NextInstance(1) = #Null
      
    EndIf
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration de la mthode Update <<<<<
  
  Procedure.s DeclareUpdate()
    
    Select Field::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE To Field::#INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam.s = Field::GetUpdateInitParam()
        
      Case Field::#INSTANCE_STYLE_OFF_MODULE
        ExtraParam.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", " + Field::GetUpdateInitParam()
        
    EndSelect
    
    ProcedureReturn Comments::Tabulation(1) + "Declare Update(" + ExtraParam + ")" + Field::#LineFeed
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration de la mthode Initialize <<<<<
  
  Procedure.s DeclareInitialize()
  
    ProcedureReturn Comments::Tabulation(1) + "Declare Initialize(" + Field::GetInstanceParam() + ")" + Field::#LineFeed
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration de la mthode Reset <<<<<
  
  Procedure.s DeclareReset()
  
    ProcedureReturn Comments::Tabulation(1) + "Declare Reset(" + Field::GetInstanceParam() + ")" + Field::#LineFeed
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition des Observateurs <<<<<
  
  Procedure.s DefineObservators()
    
    If Field::FirstInstance(0)
      
      Repeat
        
        If Field::GetFieldType(0) <> Field::#FIELD_TYPE_STRUCTURE
          
          If Field::GetFieldName(0) = "ID" And Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_MULTIPLE_ID
            
            Buffer.s + ""
            
          Else
            
            Select Field::GetFieldStyle(0)
                
              Case Field::#FIELD_STYLE_ARRAY
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE
                    Buffer + Comments::Tabulation(1) + "Procedure Get" + Field::GetFieldName(0) + "(Array Destination" + Field::GetFieldExtensionLong(0) + "(" + Str(Field::GetFieldDynamicArrayDimensionCount(0)) + "))" + Field::#TwinLineFeed
                    Buffer + Comments::Tabulation(2) + "CopyArray(Instance\" + Field::GetFieldName(0) + "(), Destination())" + Field::#TwinLineFeed
                    
                  Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME  
                    Buffer + Comments::Tabulation(1) + "Procedure Get" + Field::GetFieldName(0) + "(Array Destination" + Field::GetFieldExtensionLong(0) + "(" + Str(Field::GetFieldDynamicArrayDimensionCount(0)) + "))" + Field::#TwinLineFeed
                    Buffer + Comments::Tabulation(2) + "CopyArray(Instances()\" + Field::GetFieldName(0) + "(), Destination())" + Field::#TwinLineFeed
                    
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    Buffer + Comments::Tabulation(1) + "Procedure Get" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", Array Destination" + Field::GetFieldExtensionLong(0) + "(" + Str(Field::GetFieldDynamicArrayDimensionCount(0)) + "))" + Field::#TwinLineFeed
                    Buffer + Comments::Tabulation(2) + "CopyArray(*" + Field::GetModuleName() + "A\" + Field::GetFieldName(0) + "(), Destination())" + Field::#TwinLineFeed
                            
                EndSelect
                
              Case Field::#FIELD_STYLE_LIST
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE
                    Buffer + Comments::Tabulation(1) + "Procedure Get" + Field::GetFieldName(0) + "(List Destination" + Field::GetFieldExtensionLong(0) + "())" + Field::#TwinLineFeed
                    Buffer + Comments::Tabulation(2) + "CopyList(Instance\" + Field::GetFieldName(0) + "(), Destination())" + Field::#TwinLineFeed
                    
                  Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME 
                    Buffer + Comments::Tabulation(1) + "Procedure Get" + Field::GetFieldName(0) + "(List Destination" + Field::GetFieldExtensionLong(0) + "())" + Field::#TwinLineFeed
                    Buffer + Comments::Tabulation(2) + "CopyList(Instances()\" + Field::GetFieldName(0) + "(), Destination())" + Field::#TwinLineFeed
                    
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    Buffer + Comments::Tabulation(1) + "Procedure Get" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", List Destination" + Field::GetFieldExtensionLong(0) + "())" + Field::#LineFeed
                    Buffer + Comments::Tabulation(2) + "CopyList(*" + Field::GetModuleName() + "A\" + Field::GetFieldName(0) + "(), Destination())" + Field::#TwinLineFeed
                    
                EndSelect
                
              Case Field::#FIELD_STYLE_MAP
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE
                    Buffer + Comments::Tabulation(1) + "Procedure Get" + Field::GetFieldName(0) + "(Map Destination" + Field::GetFieldExtensionLong(0) + "())" + Field::#TwinLineFeed
                    Buffer + Comments::Tabulation(2) + "CopyMap(Instance\" + Field::GetFieldName(0) + "(), Destination())" + Field::#TwinLineFeed
                    
                  Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME
                    Buffer + Comments::Tabulation(1) + "Procedure Get" + Field::GetFieldName(0) + "(Map Destination" + Field::GetFieldExtensionLong(0) + "())" + Field::#TwinLineFeed
                    Buffer + Comments::Tabulation(2) + "CopyMap(Instances()\" + Field::GetFieldName(0) + "(), Destination())" + Field::#TwinLineFeed
                    
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    Buffer + Comments::Tabulation(1) + "Procedure Get" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", Map Destination." + Field::GetFieldExtensionShort(0) + "())" + Field::#TwinLineFeed
                    Buffer + Comments::Tabulation(2) + "CopyMap(*" + Field::GetModuleName() + "A\" + Field::GetFieldName(0) + "(), Destination())" + Field::#TwinLineFeed
                    
                EndSelect
                
              Case Field::#FIELD_STYLE_BASIC
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE
                    If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
                      Buffer + Comments::Tabulation(1) + "Procedure Get" + Field::GetFieldName(0) + "(*P_" + Field::GetFieldName(0) + Field::GetFieldExtensionLong(0) + " = #Null)" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + "If *P_" + Field::GetFieldName(0) + " <> #Null" + Field::#LineFeed
                      Buffer + Comments::Tabulation(3) + Field::GetFieldExternModuleName(0) + "::Copy(Instance\" + Field::GetFieldName(0) + ", *P_" + Field::GetFieldName(0) + ")" + Field::#LineFeed
                      Buffer + Comments::Tabulation(2) + "Else"  + Field::#LineFeed          
                      Buffer + Comments::Tabulation(3) + "ProcedureReturn Instance\" + Field::GetFieldName(0) + Field::#LineFeed
                      Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
                    ElseIf Field::GetFieldType(0) < Field::#FIELD_TYPE_STRUCTURE
                      Buffer + Comments::Tabulation(1) + "Procedure" + Field::GetFieldExtensionLong(0) + " Get" + Field::GetFieldName(0) + "(" + Field::GetInstanceParam() + ")" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + "ProcedureReturn Instance\" + Field::GetFieldAccess(0) + Field::#LineFeed
                    EndIf
                    
                  Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME  
                    If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
                      Buffer + Comments::Tabulation(1) + "Procedure Get" + Field::GetFieldName(0) + "(*P_" + Field::GetFieldName(0) + "." + Field::GetFieldExternModuleName(0) + "::" + Field::GetFieldExternModuleStructure(0)  + " = #Null)" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + "If *P_" + Field::GetFieldName(0) + " <> #Null" + Field::#LineFeed
                      Buffer + Comments::Tabulation(3) + Field::GetFieldExternModuleName(0) + "::Copy(Instances()\" + Field::GetFieldName(0) + ", *P_" + Field::GetFieldName(0) + ")" + Field::#LineFeed
                      Buffer + Comments::Tabulation(2) + "Else"  + Field::#LineFeed          
                      Buffer + Comments::Tabulation(3) + "ProcedureReturn Instances()\" + Field::GetFieldName(0) + Field::#LineFeed
                      Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
                    ElseIf Field::GetFieldType(0) < Field::#FIELD_TYPE_STRUCTURE
                      Buffer + Comments::Tabulation(1) + "Procedure" + Field::GetFieldExtensionLong(0) + " Get" + Field::GetFieldName(0) + "()" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + "ProcedureReturn Instances()\" + Field::GetFieldAccess(0) + Field::#LineFeed
                    EndIf
                            
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
                      Buffer + Comments::Tabulation(1) + "Procedure.i Get" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", *P_" + Field::GetFieldName(0) + "." + Field::GetFieldExternModuleName(0) + "::" + Field::GetFieldExternModuleStructure(0) + " = #Null)" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + "If *P_" + Field::GetFieldName(0) + " <> #Null" + Field::#LineFeed
                      Buffer + Comments::Tabulation(3) + Field::GetFieldExternModuleName(0) + "::Copy(*" + Field::GetModuleName() + "A\" + Field::GetFieldName(0) + ", *P_" + Field::GetFieldName(0) + ")" + Field::#LineFeed
                      Buffer + Comments::Tabulation(2) + "Else"  + Field::#LineFeed          
                      Buffer + Comments::Tabulation(3) + "ProcedureReturn *" + Field::GetModuleName() + "A\" + Field::GetFieldName(0) + Field::#LineFeed
                      Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
                    ElseIf Field::GetFieldType(0) < Field::#FIELD_TYPE_STRUCTURE
                      Buffer + Comments::Tabulation(1) + "Procedure" + Field::GetFieldExtensionLong(0) + " Get" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ")" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + "ProcedureReturn *" + Field::GetModuleName() + "A\" + Field::GetFieldAccess(0) + Field::#LineFeed
                    EndIf
                    
                EndSelect
                
              Case Field::#FIELD_STYLE_BASIC_ARRAY
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE
                    If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
                      Buffer + Comments::Tabulation(1) + "Procedure Get" + Field::GetFieldName(0) + "(" + Field::GetFieldArrayIndexName(0) + ".l, *P_" + Field::GetFieldName(0) + Field::GetFieldExtensionLong(0) + " = #Null)" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + "If *P_" + Field::GetFieldName(0) + " <> #Null" + Field::#LineFeed
                      Buffer + Comments::Tabulation(3) + Field::GetFieldExternModuleName(0) + "::Copy(Instance\" + Field::GetFieldName(0) + "[" + Field::GetFieldArrayIndexName(0) + "], *P_" + Field::GetFieldName(0) + ")" + Field::#LineFeed
                      Buffer + Comments::Tabulation(2) + "Else" + Field::#LineFeed          
                      Buffer + Comments::Tabulation(3) + "ProcedureReturn Instance\" + Field::GetFieldName(0) + "[" + Field::GetFieldArrayIndexName(0) + "]" + Field::#LineFeed
                      Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
                    ElseIf Field::GetFieldType(0) < Field::#FIELD_TYPE_STRUCTURE
                      Buffer + Comments::Tabulation(1) + "Procedure" + Field::GetFieldExtensionLong(0) + " Get" + Field::GetFieldName(0) + "(" + Field::GetFieldArrayIndexName(0) + ".l)" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + "ProcedureReturn Instance\" + Field::GetFieldAccess(0) + "[" + Field::GetFieldArrayIndexName(0) + "]" + Field::#LineFeed
                    EndIf
                    
                  Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME  
                    If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
                      Buffer + Comments::Tabulation(1) + "Procedure Get" + Field::GetFieldName(0) + "(" + Field::GetFieldArrayIndexName(0) + ".l, *P_" + Field::GetFieldName(0) + Field::GetFieldExtensionLong(0) + " = #Null)" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + "If *P_" + Field::GetFieldName(0) + " <> #Null" + Field::#LineFeed
                      Buffer + Comments::Tabulation(3) + Field::GetFieldExternModuleName(0) + "::Copy(Instances()\" + Field::GetFieldName(0) + "[" +Field::GetFieldArrayIndexName(0) + "], *P_" + Field::GetFieldName(0) + ")" + Field::#LineFeed
                      Buffer + Comments::Tabulation(2) + "Else" + Field::#LineFeed   
                      Buffer + Comments::Tabulation(3) + "ProcedureReturn Instances()\" + Field::GetFieldName(0) + "[" + Field::GetFieldArrayIndexName(0) + "]" + Field::#LineFeed
                      Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
                    ElseIf Field::GetFieldType(0) < Field::#FIELD_TYPE_STRUCTURE
                      Buffer + Comments::Tabulation(1) + "Procedure" + Field::GetFieldExtensionLong(0) + " Get" + Field::GetFieldName(0) + "(" + Field::GetFieldArrayIndexName(0) + ".l)" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + "ProcedureReturn Instances()\" + Field::GetFieldAccess(0) + "[" + Field::GetFieldArrayIndexName(0) + "]" + Field::#LineFeed
                    EndIf   
                    
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    Buffer + Comments::Tabulation(1) + "Procedure" + Field::GetFieldExtensionLong(0) + " Get" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", " + Field::GetFieldArrayIndexName(0) + ".l)" + Field::#TwinLineFeed
                    Buffer + Comments::Tabulation(2) + "ProcedureReturn *" + Field::GetModuleName() + "A\" + Field::GetFieldAccess(0) + "[" + Field::GetFieldArrayIndexName(0) + "]" + Field::#LineFeed
                    
                EndSelect
                
            EndSelect
            
            Buffer + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
            
          EndIf
          
        EndIf
        
      Until Field::NextInstance(0) = #Null
      
    EndIf
    
    If Field::FirstInstance(1)
      
      Repeat
        
        If Field::GetFieldType(1) <> Field::#FIELD_TYPE_STRUCTURE
          
          Select Field::GetFieldStyle(1)
              
            Case Field::#FIELD_STYLE_ARRAY
              Buffer + Comments::Tabulation(1) + "Procedure Get" + Field::GetFieldName(1) + "(Array Destination" + Field::GetFieldExtensionLong(1) + "(" + Str(Field::GetFieldDynamicArrayDimensionCount(1)) + "))" + Field::#TwinLineFeed
              Buffer + Comments::Tabulation(2) + "CopyArray(Secondary\" + Field::GetFieldAccess(1) + ", Destination())" + Field::#TwinLineFeed
              
            Case Field::#FIELD_STYLE_LIST
              Buffer + Comments::Tabulation(1) + "Procedure Get" + Field::GetFieldName(1) + "(List Destination" + Field::GetFieldExtensionLong(1) + "())" + Field::#TwinLineFeed
              Buffer + Comments::Tabulation(2) + "CopyList(Secondary\" + Field::GetFieldAccess(1) + ", Destination())" + Field::#TwinLineFeed
              
            Case Field::#FIELD_STYLE_MAP
              Buffer + Comments::Tabulation(1) + "Procedure Get" + Field::GetFieldName(1) + "(Map Destination" + Field::GetFieldExtensionLong(1) + "())" + Field::#TwinLineFeed
              Buffer + Comments::Tabulation(2) + "CopyMap(Secondary\" + Field::GetFieldAccess(1) + ", Destination())" + Field::#TwinLineFeed
              
            Case Field::#FIELD_STYLE_BASIC
              If Field::GetFieldType(1) = Field::#FIELD_TYPE_MODULE
                Buffer + Comments::Tabulation(1) + "Procedure Get" + Field::GetFieldName(1) + "(*P_" + Field::GetFieldName(1) + Field::GetFieldExtensionLong(1) + " = #Null)" + Field::#TwinLineFeed
                Buffer + Comments::Tabulation(2) + "If *P_" + Field::GetFieldName(1) + " <> #Null" + Field::#LineFeed
                Buffer + Comments::Tabulation(3) + Field::GetFieldExternModuleName(1) + "::Copy(Secondary\" + Field::GetFieldName(1) + ", *P_" + Field::GetFieldName(1) + ")" + Field::#LineFeed
                Buffer + Comments::Tabulation(2) + "Else"  + Field::#LineFeed          
                Buffer + Comments::Tabulation(3) + "ProcedureReturn Secondary\" + Field::GetFieldName(1) + Field::#LineFeed
                Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
              ElseIf Field::GetFieldType(1) < Field::#FIELD_TYPE_STRUCTURE
                Buffer + Comments::Tabulation(1) + "Procedure" + Field::GetFieldExtensionLong(1) + " Get" + Field::GetFieldName(1) + "()" + Field::#TwinLineFeed
                Buffer + Comments::Tabulation(2) + "ProcedureReturn Secondary\" + Field::GetFieldAccess(1) + Field::#LineFeed
              EndIf
              
            Case Field::#FIELD_STYLE_BASIC_ARRAY
              If Field::GetFieldType(1) = Field::#FIELD_TYPE_MODULE
                Buffer + Comments::Tabulation(1) + "Procedure Get" + Field::GetFieldName(1) + "(" + Field::GetFieldArrayIndexName(1) + ".l, *P_" + Field::GetFieldName(1) + Field::GetFieldExtensionLong(1) + " = #Null)" + Field::#TwinLineFeed
                Buffer + Comments::Tabulation(2) + "If *P_" + Field::GetFieldName(1) + " <> #Null" + Field::#LineFeed
                Buffer + Comments::Tabulation(3) + Field::GetFieldExternModuleName(1) + "::Copy(Secondary\" + Field::GetFieldName(1) + "[" + Field::GetFieldArrayIndexName(1) + "], *P_" + Field::GetFieldName(1) + ")" + Field::#LineFeed
                Buffer + Comments::Tabulation(2) + "Else"  + Field::#LineFeed          
                Buffer + Comments::Tabulation(3) + "ProcedureReturn Secondary\" + Field::GetFieldAccess(1) + Field::#LineFeed
                Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
              ElseIf Field::GetFieldType(1) < Field::#FIELD_TYPE_STRUCTURE
                Buffer + Comments::Tabulation(1) + "Procedure" + Field::GetFieldExtensionLong(1) + " Get" + Field::GetFieldName(1) + "(" + Field::GetFieldArrayIndexName(1) + ".l)" + Field::#TwinLineFeed
                Buffer + Comments::Tabulation(2) + "ProcedureReturn Secondary\" + Field::GetFieldAccess(1) + Field::#LineFeed
              EndIf
              
          EndSelect
          
          Buffer + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
          
        EndIf
        
      Until Field::NextInstance(1) = #Null
      
    EndIf
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition des Mutateurs <<<<<
  
  Procedure.s DefineMutators()
    
    If Field::FirstInstance(0)
      
      Repeat
        
        If Field::GetFieldType(0) <> Field::#FIELD_TYPE_STRUCTURE
          
          If Field::GetFieldName(0) = "ID" And Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_MULTIPLE_ID
            
            Buffer.s + ""
            
          Else
            
            Select Field::GetFieldStyle(0)
                
              Case Field::#FIELD_STYLE_ARRAY
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE
                    Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(Array Source" + Field::GetFieldExtensionLong(0) + "(" + Str(Field::GetFieldDynamicArrayDimensionCount(0)) + "))" + Field::#TwinLineFeed
                    Buffer + Comments::Tabulation(2) + "CopyArray(Source(), Instance\" + Field::GetFieldName(0) + "())" + Field::#TwinLineFeed
                    
                  Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME
                    Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(Array Source" + Field::GetFieldExtensionLong(0) + "(" + Str(Field::GetFieldDynamicArrayDimensionCount(0)) + "))" + Field::#TwinLineFeed
                    Buffer + Comments::Tabulation(2) + "CopyArray(Source(), Instances()\" + Field::GetFieldName(0) + "())" + Field::#TwinLineFeed
                    
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", Array Source" + Field::GetFieldExtensionLong(0) + "(" + Str(Field::GetFieldDynamicArrayDimensionCount(0)) + "))" + Field::#TwinLineFeed
                    Buffer + Comments::Tabulation(2) + "CopyArray(Source(), *" + Field::GetModuleName() + "A\" + Field::GetFieldName(0) + "())" + Field::#TwinLineFeed
                    
                EndSelect
                
              Case Field::#FIELD_STYLE_LIST
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE 
                    Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(List Source." + Field::GetFieldExtensionShort(0) + "())" + Field::#LineFeed
                    buffer + Comments::Tabulation(2) + "CopyList(Source(), Instance\" + Field::GetFieldName(0) + "())" + Field::#TwinLineFeed
                    
                  Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME 
                    Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(List Source." + Field::GetFieldExtensionShort(0) + "())" + Field::#TwinLineFeed
                    Buffer + Comments::Tabulation(2) + "CopyList(Source(), Instances()\" + Field::GetFieldName(0) + "())" + Field::#TwinLineFeed
                    
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", List Source" + Field::GetFieldExtensionLong(0) + "())" + Field::#TwinLineFeed
                    Buffer + Comments::Tabulation(2) + "CopyList(Source(), *" + Field::GetModuleName() + "A\" + Field::GetFieldName(0) + "())" + Field::#TwinLineFeed
                    
                EndSelect
                
              Case Field::#FIELD_STYLE_MAP
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE
                    Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(Map Source." + Field::GetFieldExtensionShort(0) + "())" + Field::#TwinLineFeed
                    Buffer + Comments::Tabulation(2) + "CopyMap(Source(), Instance\" + Field::GetFieldName(0) + "())" + Field::#TwinLineFeed
                    
                  Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME  
                    Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(Map Source." + Field::GetFieldExtensionShort(0) + "())" + Field::#TwinLineFeed
                    Buffer + Comments::Tabulation(2) + "CopyMap(Source(), Instances()\" + Field::GetFieldName(0) + "())" + Field::#TwinLineFeed
                    
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", Map Source" + Field::GetFieldExtensionLong(0) + "())" + Field::#TwinLineFeed
                    Buffer + Comments::Tabulation(2) + "CopyMap(Source(), *" + Field::GetModuleName() + "A\" + Field::GetFieldName(0) + "())" + Field::#TwinLineFeed
                    
                EndSelect
                
              Case Field::#FIELD_STYLE_BASIC
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE
                    If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
                      Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(*P_" + Field::GetFieldName(0) + "." + Field::GetFieldExternModuleName(0) + "::" + Field::GetFieldExternModuleStructure(0)  + ")" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + Field::GetFieldExternModuleName(0) + "::Copy(*P_" + Field::GetFieldName(0) + ", Instance\" + Field::GetFieldName(0) + ")" + Field::#TwinLineFeed  
                    ElseIf Field::GetFieldType(0) < Field::#FIELD_TYPE_STRUCTURE
                      Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(P_" + Field::GetFieldName(0) + Field::GetFieldExtensionLong(0) + ")" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + "Instance\" + Field::GetFieldAccess(0) + " = P_" + Field::GetFieldAccess(0) + Field::#TwinLineFeed
                    EndIf    
                    
                  Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME   
                    If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
                      Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(*P_" + Field::GetFieldName(0) + "." + Field::GetFieldExternModuleName(0) + "::" + Field::GetFieldExternModuleStructure(0) + ")" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + Field::GetFieldExternModuleName(0) + "::Copy(*P_" + Field::GetFieldName(0) + ", Instances()\" + Field::GetFieldName(0) + ")" + Field::#TwinLineFeed
                    ElseIf Field::GetFieldType(0) < Field::#FIELD_TYPE_STRUCTURE
                      Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(P_" + Field::GetFieldName(0) + Field::GetFieldExtensionLong(0) + ")" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + "Instances()\" + Field::GetFieldAccess(0) + " = P_" + Field::GetFieldAccess(0) + Field::#TwinLineFeed
                    EndIf 
                    
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
                      Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(*" + Field::GetFieldName(0) + "A." + Field::GetFieldName(0) + ", *P_" + Field::GetFieldName(0) + "." + Field::GetFieldExternModuleName(0) + "::" + Field::GetFieldExternModuleStructure(0) + ")" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + Field::GetFieldExternModuleName(0) + "::Copy(*P_" + Field::GetFieldName(0) + ", *" + Field::GetModuleName() + "A\" + Field::GetFieldName(0) + ")" + Field::#TwinLineFeed
                    ElseIf Field::GetFieldType(0) < Field::#FIELD_TYPE_STRUCTURE
                      Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", P_" + Field::GetFieldName(0) + Field::GetFieldExtensionLong(0) +")" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + "*" + Field::GetModuleName() + "A\" + Field::GetFieldAccess(0) + " = P_" + Field::GetFieldAccess(0) + Field::#TwinLineFeed
                    EndIf
                    
                EndSelect
                
              Case Field::#FIELD_STYLE_BASIC_ARRAY
                
                Select Field::GetInstanceStyle()
                    
                  Case Field::#INSTANCE_STYLE_UNIQUE
                    If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
                      Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(" + Field::GetFieldArrayIndexName(0) + ".l, *P_" + Field::GetFieldName(0) + "." + Field::GetFieldExternModuleName(0) + "::" + Field::GetFieldExternModuleStructure(0) + ")" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + Field::GetFieldExternModuleName(0) + "::Copy(*P_" + Field::GetFieldName(0) + ", Instance\" + Field::GetFieldName(0) + "[" + Field::GetFieldArrayIndexName(0) + "])" + Field::#TwinLineFeed
                    ElseIf Field::GetFieldType(0) < Field::#FIELD_TYPE_STRUCTURE
                      Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(" + Field::GetFieldArrayIndexName(0) + ".l, P_" + Field::GetFieldName(0) + Field::GetFieldExtensionLong(0) + ")" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + "Instance\" + Field::GetFieldAccess(0) + "[" + Field::GetFieldArrayIndexName(0) + "] = P_" + Field::GetFieldAccess(0) + Field::#TwinLineFeed
                    EndIf
                    
                  Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME  
                    If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
                      Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(" + Field::GetFieldArrayIndexName(0) + ".l, *P_" + Field::GetFieldName(0) + "." + Field::GetFieldExternModuleName(0) + "::" + Field::GetFieldExternModuleStructure(0) + ")" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + Field::GetFieldExternModuleName(0) + "::Copy(*P_" + Field::GetFieldName(0) + ", Instances()\" + Field::GetFieldName(0) + "[" + Field::GetFieldArrayIndexName(0) + "])" + Field::#TwinLineFeed
                    ElseIf Field::GetFieldType(0) < Field::#FIELD_TYPE_STRUCTURE
                      Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(" + Field::GetFieldArrayIndexName(0) + ".l, P_" + Field::GetFieldName(0) + Field::GetFieldExtensionLong(0) + ")" + Field::#TwinLineFeed
                      Buffer + Comments::Tabulation(2) + "Instances()\" + Field::GetFieldAccess(0) + "[" + Field::GetFieldArrayIndexName(0) + "] = P_" + Field::GetFieldAccess(0) + Field::#TwinLineFeed
                    EndIf  
                    
                  Case Field::#INSTANCE_STYLE_OFF_MODULE
                    Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(0) + "(*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", " + Field::GetFieldArrayIndexName(0) + ".l, P_" + Field::GetFieldName(0) + Field::GetFieldExtensionLong(0) + ")" + Field::#TwinLineFeed
                    Buffer + Comments::Tabulation(2) + "*" + Field::GetModuleName() + "A\" + Field::GetFieldAccess(0) + "[" + Field::GetFieldArrayIndexName(0) + "] = P_" + Field::GetFieldAccess(0) + Field::#TwinLineFeed
                EndSelect
                
            EndSelect
            
            Buffer + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
            
          EndIf
          
        EndIf
        
      Until Field::NextInstance(0) = #Null
      
    EndIf
    
    If Field::FirstInstance(1)
      
      Repeat
        
        If Field::GetFieldType(1) <> Field::#FIELD_TYPE_STRUCTURE
          
          Select Field::GetFieldStyle(1)
              
            Case Field::#FIELD_STYLE_ARRAY
              Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(1) + "(Array Source" + Field::GetFieldExtensionLong(1) + "(" + Str(Field::GetFieldDynamicArrayDimensionCount(1)) + "))" + Field::#LineFeed
              Buffer + Comments::Tabulation(2) + "CopyArray(Source(), ISecondary\" + Field::GetFieldName(1) + "())" + Field::#TwinLineFeed
              
            Case Field::#FIELD_STYLE_LIST
              Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(1) + "(List Source" + Field::GetFieldExtensionLong(1) + "())" + Field::#LineFeed
              Buffer + Comments::Tabulation(2) + "CopyList(Source(), Secondary\" + Field::GetFieldName(1) + "())" + Field::#TwinLineFeed
              
            Case Field::#FIELD_STYLE_MAP
              Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(1) + "(Map Source" + Field::GetFieldExtensionLong(1) + "())" + Field::#LineFeed
              Buffer + Comments::Tabulation(2) + "CopyMap(Source(), Secondary\" + Field::GetFieldName(1) + "())" + Field::#TwinLineFeed
              
            Case Field::#FIELD_STYLE_BASIC
              If Field::GetFieldType(1) = Field::#FIELD_TYPE_MODULE
                Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(1) + "(*P_" + Field::GetFieldName(1) + Field::GetFieldExtensionLong(1) + ")" + Field::#TwinLineFeed
                Buffer + Comments::Tabulation(2) + Field::GetFieldExternModuleName(1) + "::Copy(*P_" + Field::GetFieldName(1) + ", Secondary\" + Field::GetFieldName(1) + ")" + Field::#TwinLineFeed
              ElseIf Field::GetFieldType(1) < Field::#FIELD_TYPE_STRUCTURE
                Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(1) + "(P_" + Field::GetFieldName(1) + Field::GetFieldExtensionLong(1) + ")" + Field::#TwinLineFeed
                Buffer + Comments::Tabulation(2) + "Secondary\" + Field::GetFieldName(1) + " = P_" + Field::GetFieldName(1) + Field::#TwinLineFeed
              EndIf
              
            Case Field::#FIELD_STYLE_BASIC_ARRAY
              If Field::GetFieldType(1) = Field::#FIELD_TYPE_MODULE
                Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(1) + "(" + Field::GetFieldArrayIndexName(1) + ".l, *P_" + Field::GetFieldName(1) + "." + Field::GetFieldExternModuleName(1) + "::" + Field::GetFieldExternModuleStructure(1) + ")" + Field::#TwinLineFeed
                Buffer + Comments::Tabulation(2) + Field::GetFieldExternModuleName(1) + "::Copy(*P_" + Field::GetFieldName(1) + ", Secondary\" + Field::GetFieldName(1) + "[" + Field::GetFieldArrayIndexName(1) + "])" + Field::#TwinLineFeed
              ElseIf Field::GetFieldType(1) < Field::#FIELD_TYPE_STRUCTURE
                Buffer + Comments::Tabulation(1) + "Procedure Set" + Field::GetFieldName(1) + "(" + Field::GetFieldArrayIndexName(1) + ".l, P_" + Field::GetFieldName(1) + Field::GetFieldExtensionLong(1)  + ")" + Field::#TwinLineFeed
                Buffer + Comments::Tabulation(2) + "Secondary\" + Field::GetFieldName(1) + "[" + Field::GetFieldArrayIndexName(1) + "] = P_" + Field::GetFieldName(1) + Field::#TwinLineFeed
              EndIf
              
          EndSelect
          
          Buffer + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
          
        EndIf
        
      Until Field::NextInstance(1) = #Null
      
    EndIf
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition de la mthode Update <<<<<
  
  Procedure.s DefineUpdate()
    
    InstanceStyle.s = Field::GetInstanceAccessPath()
    
    Select Field::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE
        ExtraParam.s = Field::GetUpdateInitParam()
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID To Field::#INSTANCE_STYLE_MULTIPLE_NAME 
        ExtraParam.s = Field::GetUpdateInitParam()

      Case Field::#INSTANCE_STYLE_OFF_MODULE
        ExtraParam.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName() + ", " + Field::GetUpdateInitParam()
 
    EndSelect
    
    Buffer.s = Comments::Tabulation(1) + "Procedure Update(" + ExtraParam + ")" + Field::#TwinLineFeed
    
    If Field::FirstInstance(0)
      
      Repeat
        
        If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC
          
          If Field::GetFieldName(0) <> "ID"
            
            If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
              Buffer + Comments::Tabulation(2) + Field::GetFieldExternModuleName(0) + "::Copy(*P_" + Field::GetFieldName(0) + ", " + InstanceStyle + Field::GetFieldName(0) + ")"  + Field::#LineFeed
            ElseIf Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING01
              Buffer + Comments::Tabulation(2) + InstanceStyle + Field::GetFieldName(0) + "$ = P_" + Field::GetFieldName(0) + "$"  + Field::#LineFeed
            Else
              Buffer + Comments::Tabulation(2) + InstanceStyle + Field::GetFieldName(0) + " = P_" + Field::GetFieldName(0) + Field::#LineFeed
            EndIf
            
          EndIf 
          
        EndIf 
        
      Until Field::NextInstance(0) = #Null
      
      Buffer + Field::#LineFeed
      
    EndIf
    
    Buffer + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Oprateurs privs <<<<<
  
  Procedure.s InstructionResetBasic(TabSize.b, InstanceStyle.s, Target.b)
    
    Select Field::GetFieldType(Target)
        
      Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_QUAD
        Instruction.s = Comments::Tabulation(TabSize) + InstanceStyle + Field::GetFieldAccess(Target) + " = 0" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_FLOAT, Field::#FIELD_TYPE_DOUBLE
        Instruction = Comments::Tabulation(TabSize) + InstanceStyle + Field::GetFieldAccess(Target) + " = 0.0" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_STRING01, Field::#FIELD_TYPE_STRING02
        Instruction = Comments::Tabulation(TabSize) + InstanceStyle + Field::GetFieldAccess(Target) + " = " + Field::#EmptyString + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_MODULE
        Instruction = Comments::Tabulation(TabSize) + Field::GetFieldExternModuleName(Target) + "::Reset(" + InstanceStyle + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
    EndSelect
    
    ProcedureReturn Instruction
  EndProcedure
  
  Procedure.s InstructionResetStructure(TabSize.b, InstanceStyle.s, Target.b)
    
    Select Field::GetSubFieldType(Target)
        
      Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_QUAD
        Instruction.s = Comments::Tabulation(TabSize) + InstanceStyle + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = 0" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_FLOAT, Field::#FIELD_TYPE_DOUBLE
        Instruction = Comments::Tabulation(TabSize) + InstanceStyle + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = 0.0" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_STRING01, Field::#FIELD_TYPE_STRING02
        Instruction = Comments::Tabulation(TabSize) + InstanceStyle + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = " + Field::#EmptyString + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_MODULE
        Instruction = Comments::Tabulation(TabSize) + Field::GetSubFieldExternModuleName(Target) + "::Reset(" + InstanceStyle + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
    EndSelect 
    
    ProcedureReturn Instruction
  EndProcedure
 
  Procedure.s ResetCodeChuck(TabSize.b, InstanceAccessPath.s, Free_Or_Clear.s, Target.b)
    
    If Field::FirstInstance(Target)
      
      Repeat
        
        Select Field::GetFieldStyle(Target)
            
          Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
            SeparatorNeeded = #True
            
          Case Field::#FIELD_STYLE_BASIC
            SeparatorNeeded = #False
            
        EndSelect
        
        If Field::InstanceIndex(Target) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
          Buffer.s + Comments::Tabulation(2) + Field::#LineFeed
        EndIf 
        
        Select Field::GetFieldStyle(Target)
            
          Case Field::#FIELD_STYLE_ARRAY
            
            ;TabSize.b = 2   
            
            Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize, 0)
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionResetBasic(TabSize+1, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize + 1         
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionResetStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize2) + "FreeArray(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccessEmpty(Target) + ")" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionResetStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + Free_Or_Clear + "List(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionResetStructure(TabSize + 2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + Free_Or_Clear + "Map(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionResetStructure(TabSize+1, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionResetStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                    EndSelect   
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize+1) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize, 0) + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(TabSize) + "FreeArray(" + InstanceAccessPath + Field::GetFieldAccessEmpty(Target) + ")" + Field::#LineFeed
            
          Case Field::#FIELD_STYLE_LIST
            
            Buffer + Comments::Tabulation(TabSize) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + Field::#LineFeed
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionResetBasic(TabSize+1, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize         
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target+1, @TabSize2, 1)
                        Buffer + InstructionResetStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize2) + "FreeArray(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccessEmpty(Target) + ")" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionResetStructure(TabSize +2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + Free_Or_Clear + "List(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionResetStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + Free_Or_Clear + "Map(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionResetStructure(TabSize+1, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionResetStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize+1) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(2) + Free_Or_Clear + "List(" + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
            
          Case Field::#FIELD_STYLE_MAP
            Buffer + Comments::Tabulation(2) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + Field::#LineFeed
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionResetBasic(TabSize+1, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize+1) + Field::#LineFeed
                    EndIf 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize + 1      
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionResetStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize2) + "FreeArray(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccessEmpty(Target) + ")" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionResetStructure(TabSize + 2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize + 1) + "Next" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize + 1) + Free_Or_Clear + "List(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionResetStructure(TabSize+ 2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize + 1) + "Next" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize + 1) + Free_Or_Clear + "Map(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionResetStructure(TabSize + 1, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize + 1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionResetStructure(TabSize + 2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize + 1) + "Next"+ Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(TabSize) + Free_Or_Clear + "Map(" + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
            
          Case Field::#FIELD_STYLE_BASIC
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionResetBasic(TabSize, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(2) + Field::#LineFeed
                    EndIf 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize          
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionResetStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize2) + "FreeArray(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccessEmpty(Target) + ")" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionResetStructure(TabSize + 1, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize) + Free_Or_Clear + "List(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionResetStructure(TabSize + 1, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize) + Free_Or_Clear + "Map(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionResetStructure(TabSize, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionResetStructure(TabSize + 1, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
          Case Field::#FIELD_STYLE_BASIC_ARRAY
            
            Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetFieldArrayIndexName(Target) + " = 0 To " + Field::GetFieldArraySizeLoop(Target) + Field::#LineFeed
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionResetBasic(TabSize + 1, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize+1) + Field::#LineFeed
                    EndIf 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize + 1        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionResetStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize2) + "FreeArray(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionResetStructure(TabSize + 2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize + 1) + "Next" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize + 1) + Free_Or_Clear + "List(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionResetStructure(TabSize + 2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize + 1) + "Next" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize + 1) + Free_Or_Clear + "Map(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionResetStructure(TabSize + 1, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionResetStructure(TabSize + 2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize + 1) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(0) = Field::SubFieldSize(0) - 1
                      Buffer + Comments::Tabulation(TabSize+1) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
            
        EndSelect
        
        If Field::GetSecondaryInstance() = #False
          If Field::InstanceIndex(Target) = Field::InstanceSize(Target) - 1
            Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
          EndIf
        EndIf 
        
        PreviousSeparator = SeparatorNeeded
        
      Until Field::NextInstance(Target) = #Null
      
    EndIf
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition de la mthode Initialize <<<<<
  
  Procedure.s DefineInitialize()
    
    Buffer.s = Comments::Tabulation(1) + "Procedure Initialize(" + Field::GetInstanceParam() + ")" + Field::#LineFeed
    
    Select Field::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_OFF_MODULE
        
        Buffer + ResetCodeChuck(2, Field::GetInstanceAccessPath(), "Clear", 0)
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME
        
        TempBuffer.s = ResetCodeChuck(4, Field::GetInstanceAccessPath(), "Clear", 0)
        
        Buffer + Comments::Tabulation(2) + Field::#LineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(2) + "If " + StringField(Field::GetInstanceParam(), 1, ".") + " = -1" + Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME 
            Buffer + Comments::Tabulation(2) + "If " + StringField(Field::GetInstanceParam(), 1, ".") + " = " + Field::#EmptyString + Field::#TwinLineFeed
            
        EndSelect
        
        Buffer + Comments::Tabulation(3) + "Foreach Instances()" + Field::#LineFeed
        Buffer + TempBuffer
        Buffer + Comments::Tabulation(3) + "Next" + Field::#TwinLineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(3) + "ClearList(Instances())" + Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME 
            Buffer + Comments::Tabulation(3) + "ClearMap(Instances())" + Field::#TwinLineFeed
            
        EndSelect
        
        Buffer + Comments::Tabulation(2) + "Else" + Field::#TwinLineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(3) + "If SearchInstances(" + StringField(Field::GetInstanceParam(), 1, ".") + ") <> -1" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(3) + "If SelectElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(3) + "If FindMapElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed  
            
        EndSelect
        
        Buffer + TempBuffer
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(4) + "DeleteElement(Instances(), 1)" + Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(4) + "DeleteMapElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#TwinLineFeed
            
        EndSelect 
        
        Buffer + Comments::Tabulation(3) + "EndIf" + Field::#TwinLineFeed
        
        If Field::GetSecondaryInstance() = #False
          Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
        Else
          Buffer + Comments::Tabulation(2) + "EndIf" + Field::#LineFeed
        EndIf
        
    EndSelect
    
    If Field::GetSecondaryInstance() = #True
      Buffer + ResetCodeChuck(2, "Secondary\", "Clear", 1)
      Buffer + Comments::Tabulation(2) + Field::#LineFeed
    EndIf

    Buffer + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition de la mthode Reset <<<<<
  
  Procedure.s DefineReset()
    
    InstanceStyle.s = Field::GetInstanceAccessPath()
    
    Buffer.s = Comments::Tabulation(1) + "Procedure Reset(" + Field::GetInstanceParam() + ")" + Field::#LineFeed
    
    Select Field::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_OFF_MODULE
        Buffer + ResetCodeChuck(2, Field::GetInstanceAccessPath(), "Free", 0)

        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME
        
        TempBuffer.s = ResetCodeChuck(4, Field::GetInstanceAccessPath(), "Free", 0)
        Buffer + Comments::Tabulation(2) + Field::#LineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(2) + "If " + StringField(Field::GetInstanceParam(), 1, ".") + " = -1" + Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME 
            Buffer + Comments::Tabulation(2) + "If " + StringField(Field::GetInstanceParam(), 1, ".") + " = " + Field::#EmptyString + Field::#TwinLineFeed
            
        EndSelect
        
        Buffer + Comments::Tabulation(3) + "Foreach Instances()" + Field::#LineFeed
        Buffer + TempBuffer
        Buffer + Comments::Tabulation(3) + "Next" + Field::#TwinLineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(3) + "FreeList(Instances())" + Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME 
            Buffer + Comments::Tabulation(3) + "FreeMap(Instances())" + Field::#TwinLineFeed
            
        EndSelect
        
        Buffer + Comments::Tabulation(2) + "Else" + Field::#TwinLineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(3) + "If SearchInstances(" + StringField(Field::GetInstanceParam(), 1, ".") + ") <> -1" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(3) + "If SelectElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(3) + "If FindMapElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed  
            
        EndSelect
        
        Buffer + TempBuffer
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(4) + "DeleteElement(Instances(), 1)" + Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(4) + "DeleteMapElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#TwinLineFeed
            
        EndSelect 
        
        Buffer + Comments::Tabulation(3) + "EndIf" + Field::#TwinLineFeed
        
        If Field::GetSecondaryInstance() = #False
          Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
        Else
          Buffer + Comments::Tabulation(2) + "EndIf" + Field::#LineFeed
        EndIf
        
    EndSelect
    
    If Field::GetSecondaryInstance() = #True
      Buffer + ResetCodeChuck(2, "Secondary\", "Free", 1)
      Buffer + Comments::Tabulation(2) + Field::#LineFeed
    EndIf
    
    Buffer + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
    
    ProcedureReturn Buffer
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (159000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 beta 1 (Linux - x64)
; Folding = HAAB9
; EnableXP
; CompileSourceDirectory