; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Module - V0.9.2
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - JSONFileMethods.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 22-07-2018
; Mise  jour : 27-07-2018
; Cod pour PureBasic : V5.70 beta 1
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule JSONFileMethods

  Declare.b GetCreateLoadFile()
  Declare SetCreateLoadFile(P_CreateLoadFile.b)
  Declare Reset()
  Declare ReadPrefs(P_GroupName.s)
  Declare WritePrefs(P_GroupName.s)
  
  Declare.s DeclareCreateFile()
  Declare.s DeclareLoadFile()  
  
  Declare.s DefineCreateFile()
  Declare.s DefineLoadFile()  
  
EndDeclareModule

Module JSONFileMethods

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Dclaration de la Structure <<<<<

  Structure Instance

    CreateLoadFile.b

  EndStructure

  Global Instance.Instance

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les observateurs <<<<<

  Procedure.b GetCreateLoadFile()

    ProcedureReturn Instance\CreateLoadFile
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les mutateurs <<<<<

  Procedure SetCreateLoadFile(P_CreateLoadFile.b)

    Instance\CreateLoadFile = P_CreateLoadFile

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Reset <<<<<

  Procedure Reset()
    
    Instance\CreateLoadFile = 0
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Lecture d'un groupe Prfrences <<<<<

  Procedure ReadPrefs(P_GroupName.s)

    PreferenceGroup(P_GroupName)
    
    Instance\CreateLoadFile = ReadPreferenceLong("CreateLoadFile", Instance\CreateLoadFile)
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture d'un groupe de Prfrences <<<<<

  Procedure WritePrefs(P_GroupName.s)

    PreferenceGroup(P_GroupName)
    
    WritePreferenceLong("CreateLoadFile", Instance\CreateLoadFile)
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture d'un groupe de Prfrences <<<<<
  
  Procedure.s DeclareCreateFile()
    
    Select Field::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE
        ExtraParam.s = ""
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam.s = ", " + Field::GetInstanceID() + " = -1"
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam.s = ", " + Field::GetInstanceID() + " = " + Field::#EmptyString
        
      Case Field::#INSTANCE_STYLE_OFF_MODULE
        ExtraParam.s = ", *" + Field::GetModuleName() + "A." + Field::GetModuleName()
        
    EndSelect
    
    ProcedureReturn Comments::Tabulation(1) + "Declare Create" + Field::GetModuleName() + "JSONFile(FileID.l, FileName.s" + ExtraParam + ")" + Field::#LineFeed
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture d'un groupe de Prfrences <<<<<
  
  Procedure.s DeclareLoadFile()  
    
    Select Field::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE
        ExtraParam.s = ""
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam.s = ", " + Field::GetInstanceID() + " = -1"
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam.s = ", " + Field::GetInstanceID() + " = " + Field::#EmptyString
        
      Case Field::#INSTANCE_STYLE_OFF_MODULE
        ExtraParam.s = ", *" + Field::GetModuleName() + "A." + Field::GetModuleName()
        
    EndSelect
    
    ProcedureReturn Comments::Tabulation(1) + "Declare Load" + Field::GetModuleName() + "JSONFile(FileID.l, FileName.s" + ExtraParam + ")" + Field::#LineFeed
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture d'un groupe de Prfrences <<<<<
  
  Procedure.s DefineCreateFile()
    
    Select Field::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE
        ExtraParam.s = ""
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam.s = ", " + Field::GetInstanceID() + " = -1"
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam.s = ", " + Field::GetInstanceID() + " = " + Field::#EmptyString
        
      Case Field::#INSTANCE_STYLE_OFF_MODULE
        ExtraParam.s = ", *" + Field::GetModuleName() + "A." + Field::GetModuleName()
        
    EndSelect
    
    Output.s = Comments::Tabulation(1) + "Procedure Create" + Field::GetModuleName() + "JSONFile(FileID.l, P_FileName.s" + ExtraParam + ")" + Field::#TwinLineFeed
    Output + Comments::Tabulation(2) + "FileHandle = CreateJSON(FileID, #PB_JSON_NoCase)" + Field::#TwinLineFeed
    Output + Comments::Tabulation(2) + "If FileID = #PB_Any" + Field::#LineFeed
    Output + Comments::Tabulation(3) + "FileID = FileHandle" + Field::#LineFeed
    Output + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
    Output + Comments::Tabulation(2) + "If IsJSON(FileID)" + Field::#LineFeed
    
    Select Field::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE
        Output + Comments::Tabulation(3) + "InsertJSONStructure(JSONValue(FileID), @Instance, Instance)" + Field::#LineFeed
        
      Case Field::#INSTANCE_STYLE_OFF_MODULE
        Output + Comments::Tabulation(3) + "InsertJSONStructure(JSONValue(FileID), *" + Field::GetModuleName() + "A, " +  Field::GetModuleName() + ")" + Field::#LineFeed
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID To Field::#INSTANCE_STYLE_MULTIPLE_NAME    
        Output + Comments::Tabulation(3) + "InsertJSONList(JSONValue(FileID), Instances())" + Field::#LineFeed
        
    EndSelect
    
    Output + Comments::Tabulation(3) + "SaveJSON(FileID, P_FileName, #PB_JSON_PrettyPrint)" + Field::#LineFeed
    Output + Comments::Tabulation(3) + "FreeJSON(FileID)" + Field::#LineFeed
    Output + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
    
    Output + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture d'un groupe de Prfrences <<<<<
  
  Procedure.s DefineLoadFile()  
    
    Select Field::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE
        ExtraParam.s = ""
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam.s = ", " + Field::GetInstanceID() + " = -1"
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam.s = ", " + Field::GetInstanceID() + " = " + Field::#EmptyString
        
      Case Field::#INSTANCE_STYLE_OFF_MODULE
        ExtraParam.s = ", *" + Field::GetModuleName() + "A." + Field::GetModuleName()
        
    EndSelect
    
    Output.s = Comments::Tabulation(1) + "Procedure Load" + Field::GetModuleName() + "JSONFile(FileID.l, P_FileName.s" + ExtraParam + ")" + Field::#TwinLineFeed
    Output + Comments::Tabulation(2) + "FileHandle = LoadJSON(FileID, P_FileName, #PB_JSON_NoCase)" + Field::#TwinLineFeed
    Output + Comments::Tabulation(2) + "If FileID = #PB_Any" + Field::#LineFeed
    Output + Comments::Tabulation(3) + "FileID = FileHandle" + Field::#LineFeed
    Output + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
    Output + Comments::Tabulation(2) + "If IsJSON(FileID)" + Field::#LineFeed
    
    Select Field::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE
        Output + Comments::Tabulation(3) + "ExtractJSONStructure(JSONValue(FileID), @Instance, Instance)" + Field::#LineFeed
        
      Case Field::#INSTANCE_STYLE_OFF_MODULE
        Output + Comments::Tabulation(3) + "ExtractJSONStructure(JSONValue(FileID), *" + Field::GetModuleName() + "A, " +  Field::GetModuleName() + ")" + Field::#LineFeed
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID To Field::#INSTANCE_STYLE_MULTIPLE_NAME    
        Output + Comments::Tabulation(3) + "ExtractJSONList(JSONValue(FileID), Instances())" + Field::#LineFeed
        
    EndSelect
    
    Output + Comments::Tabulation(3) + "FreeJSON(FileID)" + Field::#LineFeed
    Output + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
    
    Output + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
    
    ProcedureReturn Output
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (91000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 beta 1 (Linux - x64)
; Folding = -8-
; EnableXP
; CompileSourceDirectory