; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - Main.pb
; Version du fichier : 0.9.9
; Programmation : En cours
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 03-10-2014
; Mise  jour : 14-07-2018
; Code PureBasic : V5.70
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Notes de programmation
;
; DONE : Mthodes Get (Basic)
; DONE : Mthodes Set (Basic)
; DONE : Mthode Update (Basic)
; DONE : Mthode Initialize (Basic)
; DONE : Mthode Reset (Basic)
; 
; DONE : Mthode QuickSortAscendent (StaticArray)
; DONE : Mthode QuickSortDescendent (StaticArray)
; DONE : Mthode LinearSearch (StaticArray)
; DONE : Mthode BinarySearch (StaticArray)
; DONE : Mthode FixedLenghtQueue (StaticArray)
; 
; DONE : Mthode Sort (LinkedList)
; DONE : Mthode LinearSearch (LinkedList)
; DONE : Mthode BinarySearch (LinkedList)

; DONE : Mthode Sort (DynamicArray)
; DONE : Mthode LinearSearch (DynamicArray)
; DONE : Mthode BinarySearch (DynamicArray)

; DONE : Mthode Equal (Maths)
; DONE : Mthode Plus (Maths)
; DONE : Mthode Minus (Maths)
; DONE : Mthode Product (Maths)
; DONE : Mthode Divide (Maths)
; DONE : Mthode ProductByScalar (Maths)
; DONE : Mthode DivideByScalar (Maths)
; DONE : Mthode Copy (Maths)
; DONE : Mthode Compare (Maths)
; DONE : Mthode Swapping (Maths)
; DONE : Mthode Identity (Maths)
; DONE : Mthode Transpose (Maths)
; DONE : Mthode SelfTranspose (Maths)
; DONE : Mthode Determinant (Maths)
; DONE : Mthode Inverse (Maths)
; DONE : Mthode Randomize (Maths)
; DONE : Mthode FormatLine (Maths)
; DONE : Mthode UnformatLine (Maths)
;
; TODO : Mthode NodeWithChildNode (XML File)
; DONE : Mthode NodeWithAttributes (XML File)
; DONE : Mthode AddCollectAttributes (XML File)
; DONE : Mthode CreateLoadFile (XML File)
; DONE : Mthode CatchFile (XML File)
;
; DONE : Mthode CreateLoadFile (JSON File)
;
; DONE : Read/Write Group (Prefs)
; DONE : Create/Load File (Prefs)
;
; DONE : Read/Write (Fichier Binaire)
; DONE : CreateFile (Fichier Binaire)
; DONE : OpenFile (Fichier Binaire)
; DONE : ReadFile (Fichier Binaire)
;
; DONE : Read/Write (Fichier Encod)
; DONE : CreateFile (Fichier Encod)
; DONE : OpenFile (Fichier Encod)
; DONE : ReadFile (Fichier Encod)
;
; DONE : Read/Write (Fichier Crypt)
; DONE : CreateFile (Fichier Crypt)
; DONE : OpenFile (Fichier Crypt)
; DONE : ReadFile (Fichier Crypt)
;
; DONE : Ajouter pour tout les OptionGadget() celle qui doit tre par dfaut au dpart.
;
; DONE : Ajouter un message d'erreur lorsqu'il n'y a plus de masque pour la date. 
; 
; VERSION 1.1.0 : tudier pour ajouter la gnration des mthodes Get/Set pour les champs Structurs
;
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

IncludeFile "TOOLBOX/ButtonImageGroup - Module.pb"
IncludeFile "TOOLBOX/Sticky - Module.pb"
IncludeFile "TOOLBOX/FormatColor - Module.pb"
IncludeFile "TOOLBOX/Language System - Module.pb"
IncludeFile "TOOLBOX/Window - Module.pb"
IncludeFile "TOOLBOX/Gadget Locate - Module.pb"
IncludeFile "TOOLBOX/OptionGroup - Module.pb"
IncludeFile "TOOLBOX/ButtonGroup - Module.pb"
IncludeFile "TOOLBOX/PastedCodeCleanUp - Module.pb"
IncludeFile "TOOLBOX/StringBetween - Module.pb"
IncludeFile "TOOLBOX/DependentGadgets - Module.pb"
IncludeFile "TOOLBOX/BuiltPathDirectory - Module.pb"
IncludeFile "TOOLBOX/CheckFileExtension - Module.pb"
IncludeFile "TOOLBOX/Chrono - Module.pb"
IncludeFile "TOOLBOX/AskPureBasicCompiler - Module.pb"
IncludeFile "TOOLBOX/AdvancedDateFormatting - Module.pb"
IncludeFile "TOOLBOX/Max - Module.pb"
IncludeFile "TOOLBOX/FormatDouble - Module.pb"
IncludeFile "TOOLBOX/FormatMilliSeconds - Module.pb"
IncludeFile "TOOLBOX/ColorPreview Gadget - Module.pb"
IncludeFile "TOOLBOX/RgbToHtml - Module.pb"
IncludeFile "TOOLBOX/ProgressBarEx - Module.pb"
IncludeFile "TOOLBOX/Vector3 Double - Module.pb"
IncludeFile "TOOLBOX/Vector4 Double - Module.pb"
IncludeFile "TOOLBOX/Vector5 Double - Module.pb"
IncludeFile "TOOLBOX/Matrix33 Double - Module.pb"
IncludeFile "TOOLBOX/Matrix44 Double - Module.pb"
IncludeFile "TOOLBOX/Matrix55 Double - Module.pb"

CompilerIf #PB_Compiler_OS = #PB_OS_Linux
  ImportC "-no-pie" : EndImport ; Fix Compiled Program flagged as Shared library
CompilerEndIf

IncludeFile "DevModule - Help.pb"
IncludeFile "DevModule - Stats.pb"
IncludeFile "DevModule - Options.pb"
IncludeFile "DevModule - Comments.pb"
IncludeFile "DevModule - Field.pb"

IncludeFile "DevModule - BasicMethods.pb"
IncludeFile "DevModule - StaticArrayMethods.pb"
IncludeFile "DevModule - LinkedListMethods.pb"
IncludeFile "DevModule - DynamicArrayMethods.pb"
IncludeFile "DevModule - MathsMethods.pb"
IncludeFile "DevModule - XMLFileMethods.pb"
IncludeFile "DevModule - JSONFileMethods.pb"
IncludeFile "DevModule - DataBaseMethods.pb"
IncludeFile "DevModule - PrefsFileMethods.pb"
IncludeFile "DevModule - BinaryFileMethods.pb"
IncludeFile "DevModule - EncodedFileMethods.pb"
IncludeFile "DevModule - CryptedFileMethods.pb"
IncludeFile "DevModule - DebuggingMethods.pb"

IncludeFile "DevModule - MatrixEncodedGenerator.pb"
IncludeFile "DevModule - CodeGenerator.pb"
IncludeFile "DevModule - MatrixGenerator.pb"
IncludeFile "DevModule - DevModule.pb"

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Routine d'initialisation du programme <<<<<

DevModule::Initialize() 

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Ouverture de la fentre principale <<<<<

DevModule::CreateWindow()

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Gestion des vnements <<<<<

DevModule::EventManager()

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 beta 1 (Linux - x64)
; Folding = -
; EnableThread
; EnableXP
; Executable = ../../../Programmes/DevModule/DevModule
; DisableDebugger
; CompileSourceDirectory
; EnableUnicode