; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : BuiltPathDirectory - Module
; Fichier : BuiltPathDirectory - Module.pb
; Version : 1.1.0
; Programmation : OK
; Programm par : Guillaume
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 29-04-2008
; Mise  jour : 21-02-2015
; Cod avec PureBasic V5.31
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule BuiltPathDirectory
  
  Declare.b DoIt(Path.s)
  
EndDeclareModule

Module BuiltPathDirectory
  
  CompilerSelect #PB_Compiler_OS
      
    CompilerCase #PB_OS_Windows 
      #PathSep = "\"
      
    CompilerCase #PB_OS_Linux
      #PathSep = "/"
      
    CompilerCase #PB_OS_MacOS
      #PathSep = "/"
      
  CompilerEndSelect
  
  Procedure.b DoIt(Path.s)
    
    DirectoryQty = CountString(Path, #PathSep) + 1 
    
    For Index = 1 To DirectoryQty
      
      Directory.s = Directory + StringField(Path, Index, #PathSep) + #PathSep
      
      If FileSize(Directory) = -1
        CreateDirectory(Directory)
      EndIf 
      
    Next
    
    If FileSize(Path) = -2
      Success.b = #True
    Else
      Success = #False
    EndIf
    
    ProcedureReturn Success
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 beta 1 (Linux - x64)
; Folding = -
; EnableXP
; CompileSourceDirectory